local success = "|cffffd200ZHunter:|r %s's |cff20ff20%s|r was dispelled!"
local failure = "|cffffd200ZHunter:|r |cffff2020Failed|r to dispel %s's |cff20ff20%s|r!"
local desiredSpells = {}
local channels = {"party", "raid", "channel", "raid_warning"}
local validate = {GetNumPartyMembers, GetNumRaidMembers, function() return 1 end, function() if IsRaidOfficer() or IsRaidLeader() then return 1 else return 0 end end}

function ZArcaneDispelParse(spells)
	if not spells then return end
	for i in pairs(desiredSpells) do
		desiredSpells[i] = nil
	end
	for i, v in pairs({strsplit("\n", spells)}) do
		desiredSpells[v] = true
	end
end

function ZArcaneDispel(destName, extraSpellName, failed)
	if not ZHunterMod_Saved["ZArcaneDispel"].on then return end
	-- Grab a local copy of the options
	local tbl = ZHunterMod_Saved["ZArcaneDispel"]
	-- Setup and broadcast the message
	if not failed then
		local message = tbl.format or ">$spell< dispelled from $player"
		message = message:gsub("$player", destName)
		message = message:gsub("$spell", extraSpellName)
		for i = 1, 4 do
			local channel = channels[i]
			if tbl[channel] or (tbl[channel] == nil and desiredSpells[extraSpellName]) then
				if validate[i]() > 0 then
					SendChatMessage(message, channel, nil, tbl.channelNum)
				end
			end
		end
	end
	-- Display personal notification
	if tbl.toSelf then
		if failed then
			if tbl.showFail then
				DEFAULT_CHAT_FRAME:AddMessage(failure:format(destName, extraSpellName))
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage(success:format(destName, extraSpellName))
		end
	end
end