local f = CreateFrame("frame")

f:RegisterEvent("UNIT_SPELLCAST_SENT")
f:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")

f:SetScript("OnEvent", function(self, event, unit, spell, _, player)
	if not ZHunterMod_Saved["ZMisdirect"]["on"] then return end
	if unit == "player" and spell == ZHUNTER_MISDIRECT then
		if event == "UNIT_SPELLCAST_SENT" then
			self.player = player
		elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
			ZMisdirect_Announce(self.player)
		end

	end
end)

function ZMisdirect_Announce(player)
	if not player then return end
	local t = ZHunterMod_Saved["ZMisdirect"]
	local msg = t["format"]:gsub("$player", player)
	if t["channel"] > 0 then
		SendChatMessage(msg, "channel", nil, t["channel"])
	end
	if t["raid"] and UnitExists("raid1") then
		SendChatMessage(msg, "raid")
	end
	if t["party"] and UnitExists("party1") then
		SendChatMessage(msg, "party")
	end
	if t["yell"] then
		SendChatMessage(msg, "yell")
	end
	if t["say"] then
		SendChatMessage(msg, "say")
	end
	if t["emote"] then
		SendChatMessage(msg, "emote")
	end
	if t["guild"] then
		SendChatMessage(msg, "guild")
	end
end