function ZHunterModOptionsMenu_Load()
	ZHunterModOptionsMenu:Show()
end

local OptionsFrame = LibStub("AceGUI-3.0"):Create("Frame")
OptionsFrame:Hide()

SLASH_ZHunter1 = "/ZHunter"
SLASH_ZHunter2 = "/ZHunterMod"
SlashCmdList["ZHunter"] = function(msg)
	if msg == "old" then
		ZHunterModOptionsMenu_Load()
	else
	LibStub("AceConfigDialog-3.0"):Open("ZHunterMod", OptionsFrame)
	OptionsFrame:SetWidth(500)
	OptionsFrame:SetHeight(500)
	end
end

function ZHunterMod_AlignButtons(direction, distance)
	local t = {}
	t["BOTTOM"] = "TOP"
	t["TOP"] = "BOTTOM"
	t["LEFT"] = "RIGHT"
	t["RIGHT"] = "LEFT"
	distance = tonumber(distance) or 0
	local x, y = 0, 0
	direction = string.upper(direction or "BOTTOM")
	if direction == "TOP" or direction == "BOTTOM" then
		y = distance
	elseif direction == "LEFT" or direction == "RIGHT" then
		x = distance
	else
		direction = "BOTTOM"
		y = distance
	end
	if direction == "LEFT" or direction == "BOTTOM" then
		x = x * -1
		y = y * -1
	end
	ZTrack:ClearAllPoints()
	ZTrack:SetPoint(t[direction], ZAspect, direction, x, y)
	ZTrap:ClearAllPoints()
	ZTrap:SetPoint(t[direction], ZTrack, direction, x, y)
	ZPet:ClearAllPoints()
	ZPet:SetPoint(t[direction], ZTrap, direction, x, y)
end

function ZHunterModSpellSizeSlider_OnValueChanged(self)
	if not ZHunterMod_Saved then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(format("%0.2f%%", value))
	ZHunterMod_Saved[addon or ""]["size"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateSize(value)
	end
end

function ZHunterModSpellCountSlider_OnValueChanged(self)
	if not ZHunterMod_Saved then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(value)
	ZHunterMod_Saved[addon or ""]["count"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateCount(value)
	end
end

function ZHunterModSpellRowSlider_OnValueChanged(self)
	if not ZHunterMod_Saved then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = self:GetValue()
	getglobal(self:GetName().."Label"):SetText(value)
	ZHunterMod_Saved[addon or ""]["row"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateLayout(nil, nil, value)
	end
end

function ZHunterModSpellOrder_PlusClicked(self)
	local id = self:GetParent():GetID()
	if id == 1 then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local order = ZHunterMod_Saved[addon or ""]["order"][(id - 1)]
	local spell = ZHunterMod_Saved[addon or ""]["spell"][(id - 1)]
	ZHunterMod_Saved[addon or ""]["order"][(id - 1)] = ZHunterMod_Saved[addon or ""]["order"][id]
	ZHunterMod_Saved[addon or ""]["spell"][(id - 1)] = ZHunterMod_Saved[addon or ""]["spell"][id]
	ZHunterMod_Saved[addon or ""]["order"][id] = order
	ZHunterMod_Saved[addon or ""]["spell"][id] = spell
	local prev = getglobal("ZHunterModSpellOrderOptionsOrder"..(id - 1).."Text")
	local curr = getglobal("ZHunterModSpellOrderOptionsOrder"..id.."Text")
	prev:SetText(ZHunterMod_Saved[addon or ""]["spell"][(id - 1)])
	curr:SetText(spell)
	getglobal(addon):Update()
end

function ZHunterModSpellOrder_MinusClicked(self)
	local id = self:GetParent():GetID()
	local next = getglobal("ZHunterModSpellOrderOptionsOrder"..(id + 1))
	if not next or not next:IsVisible() then return end
	local addon = ZHunterModAddOnDropDownText:GetText()
	local order = ZHunterMod_Saved[addon or ""]["order"][(id + 1)]
	local spell = ZHunterMod_Saved[addon or ""]["spell"][(id + 1)]
	ZHunterMod_Saved[addon or ""]["order"][(id + 1)] = ZHunterMod_Saved[addon or ""]["order"][id]
	ZHunterMod_Saved[addon or ""]["spell"][(id + 1)] = ZHunterMod_Saved[addon or ""]["spell"][id]
	ZHunterMod_Saved[addon or ""]["order"][id] = order
	ZHunterMod_Saved[addon or ""]["spell"][id] = spell
	next = getglobal("ZHunterModSpellOrderOptionsOrder"..(id + 1).."Text")
	local curr = getglobal("ZHunterModSpellOrderOptionsOrder"..id.."Text")
	next:SetText(ZHunterMod_Saved[addon or ""]["spell"][(id + 1)])
	curr:SetText(spell)
	getglobal(addon):Update()
end

function ZHunterModSpellMore_OnClick(self)
	if ZHunterModSpellButtonOptions:IsVisible() then
		ZHunterModSpellButtonOptions:Hide()
		ZHunterModSpellOrderOptions:Show()
	else
		ZHunterModSpellButtonOptions:Show()
		ZHunterModSpellOrderOptions:Hide()
	end
end

function ZHunterModOptions_Enabled(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local frame = getglobal(addon or "")
	if type(ZHunterMod_Saved[addon or ""]) == "table" then
		if self:GetChecked() then
			ZHunterMod_Saved[addon or ""]["on"] = true
			if frame then
				frame:Show()
			end
		else
			ZHunterMod_Saved[addon or ""]["on"] = false
			if frame then
				frame:Hide()
			end
		end
	end
end

function ZHunterModOptions_SetupMenuItems()
	ZHunterModSpellSizeSlider:SetMinMaxValues(0.5, 2)
	ZHunterModSpellCountSlider:SetMinMaxValues(1, 12)
	ZHunterModSpellRowSlider:SetMinMaxValues(1, 12)
	ZHunterModSpellSizeSlider:SetValueStep(0.01)
	ZHunterModSpellCountSlider:SetValueStep(1)
	ZHunterModSpellRowSlider:SetValueStep(1)
	UIDropDownMenu_Initialize(ZHunterModSpellShowDropDown, ZHunterModSpellShowDropDown_Update)
	UIDropDownMenu_Initialize(ZHunterModSpellExpandDropDown, ZHunterModSpellExpandDropDown_Update)
	UIDropDownMenu_Initialize(ZHunterModSpellRowDropDown, ZHunterModSpellRowDropDown_Update)
end

function ZHunterModAddOnDropDown_Update()
	local info = {}
	info.func = ZHunterModAddOnDropDown_OnClick
	info.notCheckable = 1
	local t = {"ZAspect", "ZTrack", "ZTrap", "ZPet", "ZAutoShot", "ZAutoStrip", "ZHunterTranq", "ZMisdirect", "ZAntiDaze", "ZFeignHealth", "ZArcaneDispel"}
	for i=1, table.getn(t) do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellShowDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellShowDropDown_OnClick
	info.notCheckable = 1
	local t = {"OnMouseOver", "OnRightClick", "Always"}
	for i=1, 3 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellExpandDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellExpandDropDown_OnClick
	info.notCheckable = 1
	local t = {"LEFT", "RIGHT", "TOP", "BOTTOM"}
	for i=1, 4 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModSpellRowDropDown_Update()
	local info = {}
	info.func = ZHunterModSpellRowDropDown_OnClick
	info.notCheckable = 1
	local t = {"LEFT", "RIGHT", "TOP", "BOTTOM"}
	for i=1, 4 do
		info.text = t[i]
		info.value = t[i]
		UIDropDownMenu_AddButton(info)
	end
end

function ZHunterModAddOnDropDown_OnClick()
	local addon = ZHunterModAddOnDropDownText:GetText()
	local value = this.value
	ZHunterModAddOnDropDownText:SetText(value)
	ZHunterModOptionEnabled:SetChecked(ZHunterMod_Saved[value or ""]["on"])

	ZHunterModBroadcastOptions:Hide()
	ZHunterModSpellOrderOptions:Hide()
	ZHunterModSpellButtonOptions:Hide()
	ZHunterModSpellMore:Hide()
	if value == "ZAspect" or value == "ZTrack" or value == "ZTrap" or value == "ZPet" then
		ZHunterModSpellSizeSlider:SetValue(ZHunterMod_Saved[value or ""]["size"] or 1)
		ZHunterModSpellCountSlider:SetValue(ZHunterMod_Saved[value or ""]["count"] or 12)
		ZHunterModSpellRowSlider:SetValue(ZHunterMod_Saved[value or ""]["row"] or 1)
		ZHunterModSpellShowDropDownText:SetText(ZHunterMod_Saved[value or ""]["event"])
		ZHunterModSpellExpandDropDownText:SetText(ZHunterMod_Saved[value or ""]["direction"])
		ZHunterModSpellRowDropDownText:SetText(ZHunterMod_Saved[value or ""]["stack"])
		for i=1, 12 do
			local button = getglobal("ZHunterModSpellOrderOptionsOrder"..i.."Text")
			local spell = ZHunterMod_Saved[value]["spell"][i]
			if spell then
				button:SetText(spell)
				button:GetParent():Show()
			else
				button:GetParent():Hide()
			end
		end
		ZHunterModSpellButtonOptions:Show()
		ZHunterModSpellMore:Show()
	elseif value == "ZMisdirect" then
		ZHunterModBroadcastOptionsRaid:SetChecked(ZHunterMod_Saved[value or ""]["raid"])
		ZHunterModBroadcastOptionsParty:SetChecked(ZHunterMod_Saved[value or ""]["party"])
		ZHunterModBroadcastOptionsYell:SetChecked(ZHunterMod_Saved[value or ""]["yell"])
		ZHunterModBroadcastOptionsSay:SetChecked(ZHunterMod_Saved[value or ""]["say"])
		ZHunterModBroadcastOptionsEmote:SetChecked(ZHunterMod_Saved[value or ""]["emote"])
		ZHunterModBroadcastOptionsGuild:SetChecked(ZHunterMod_Saved[value or ""]["guild"])
		ZHunterModBroadcastOptionsChannel:SetChecked(ZHunterMod_Saved[value or ""]["channel"])
		ZHunterModBroadcastOptionsChannelNumber:SetText(ZHunterMod_Saved[value or ""]["channel"])
		ZHunterModBroadcastOptions:Show()
	else

	end
end

function ZHunterModSpellShowDropDown_OnClick()
	local value = this.value
	ZHunterModSpellShowDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["event"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateAnchor(value)
	end
end

function ZHunterModSpellExpandDropDown_OnClick()
	local value = this.value
	ZHunterModSpellExpandDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["direction"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateLayout(value)
	end
end

function ZHunterModSpellRowDropDown_OnClick()
	local value = this.value
	ZHunterModSpellRowDropDownText:SetText(value)
	local addon = ZHunterModAddOnDropDownText:GetText()
	ZHunterMod_Saved[addon or ""]["row"] = value
	local frame = getglobal(addon)
	if frame then
		frame:UpdateLayout(nil, value)
	end
end

function ZHunterModBroadcast_OnClick(self)
	local buttons = {"raid", "party", "yell", "say", "emote", "guild", "channel"}
	local addon = ZHunterModAddOnDropDownText:GetText()
	local id = self:GetID()
	if id == 7 then
		if self:GetChecked() then
			ZHunterMod_Saved[addon or ""]["channel"] = 1
		else
			ZHunterMod_Saved[addon or ""]["channel"] = 0
		end
		ZHunterModBroadcastOptionsChannelNumber:SetText(ZHunterMod_Saved[addon or ""]["channel"])
	else
		ZHunterMod_Saved[addon or ""][buttons[id]] = self:GetChecked() and true or false
	end
end

function ZHunterModBroadcast_OnChange(self)
	local addon = ZHunterModAddOnDropDownText:GetText()
	local msg = self:GetText()
	if not (tonumber(msg) or msg == "") then
		self:SetText(ZHunterMod_Saved[addon or ""]["channel"] or 0)
	else
		ZHunterMod_Saved[addon or ""]["channel"] = tonumber(msg)
	end
end