local spells = {
	ZHUNTER_TRACK_HIDDEN,
	ZHUNTER_TRACK_HUMANOIDS,
	ZHUNTER_TRACK_BEASTS,
	ZHUNTER_TRACK_DEMONS,
	ZHUNTER_TRACK_ELEMENTALS,
	ZHUNTER_TRACK_UNDEAD,
	ZHUNTER_TRACK_DRAGONKIN,
	ZHUNTER_TRACK_GIANTS,
	ZHUNTER_TRACK_MINERALS,
	ZHUNTER_TRACK_HERBS,
	ZHUNTER_TRACK_TREASURE,
	ZHUNTER_TRACK_FISH
}
local numSpells = table.getn(spells)
for i = 1, numSpells do
	ZHunterModOptions.args.track.args["button"..i] = {
		type = "select",
		name = "Button "..i,
		desc = "Select which spell to use.",
		values = spells,
		style = "dropdown",
		order = 7 + i,
		get = function(info)
			local id = tonumber(info[2]:match("(%d+)"))
			return ZHunterMod_Saved["ZTrack"]["order"][id]
		end,
		set = function(info, v)
			local id = tonumber(info[2]:match("(%d+)"))
			ZHunterMod_Saved["ZTrack"]["order"][id] = v
			if ZTrack then
				ZTrack:Update()
			end
		end
	}
end

local buffs = {}
local texture = "Interface\\Icons\\Spell_Nature_WispSplode"
local BOOKTYPE_SPELL = BOOKTYPE_SPELL
local pairs = pairs

function ZTrack:Initialize()
	ZHunterMod_Saved["ZTrack"]["spell"] = {}
	for i = 1, numSpells do
		ZHunterMod_Saved["ZTrack"]["spell"][i] = spells[ZHunterMod_Saved["ZTrack"]["order"][i]]
	end
	self.spells = ZHunterMod_Saved["ZTrack"]["spell"]
	self.anchorevent = ZHunterMod_Saved["ZTrack"]["event"]
	self.direction = ZHunterMod_Saved["ZTrack"]["direction"]
	self.size = ZHunterMod_Saved["ZTrack"]["size"]
	self.count = ZHunterMod_Saved["ZTrack"]["count"]
	self.stack = ZHunterMod_Saved["ZTrack"]["stack"]
	self.rows = ZHunterMod_Saved["ZTrack"]["row"]
end

function ZTrack:OnLoad()
	-- Hide the button if disabled
	if (not ZHunterMod_Saved["ZTrack"]["on"]) then
		self:Hide()
	end
	-- Register custom events
	self:RegisterEvent("COMBAT_TEXT_UPDATE")
	self:RegisterEvent("PLAYER_DEAD")
	-- Find the names of all spells
	local list = {}
	local num = self.numButtons
	for i = 1, num do
		list[GetSpellName(self.buttons[i].id, BOOKTYPE_SPELL)] = i
	end
	-- Check to see which buffs are already active
	local count = GetNumTrackingTypes()
	for i = 1, count do
		local name, _, active = GetTrackingInfo(i)
		local num = list[name]
		if (num and active) then
			self.buttons[num].icon:SetTexture(texture)
			buffs[num] = 1
		end
	end
end

function ZTrack:OnEvent()
	if (event == "COMBAT_TEXT_UPDATE") then
		if (arg1 == "AURA_START" or arg1 == "AURA_END") then
			local num = self.numButtons
			for i = 1, num do
				local id = self.buttons[i].id
				if (id) then
					if (GetSpellName(id, BOOKTYPE_SPELL) == arg2) then
						if (arg1 == "AURA_START") then
							self.buttons[i].icon:SetTexture(texture)
							buffs[i] = 1
						elseif (arg1 == "AURA_END") then
							self.buttons[i].icon:SetTexture(GetSpellTexture(id, BOOKTYPE_SPELL))
							buffs[i] = nil
						end
						return
					end
				end
			end
		end
	elseif (event == "PLAYER_DEAD") then
		for i in pairs(buffs) do
			self.buttons[i].icon:SetTexture(GetSpellTexture(self.buttons[i].id, BOOKTYPE_SPELL))
			buffs[i] = nil
		end
	end
end