local spells = {
	ZHUNTER_TRAP_SNAKE,
	ZHUNTER_TRAP_FREEZING,
	ZHUNTER_TRAP_FROST,
	ZHUNTER_TRAP_IMMOLATION,
	ZHUNTER_TRAP_EXPLOSIVE,
	ZHUNTER_FEIGN
}
local numSpells = table.getn(spells)
for i = 1, numSpells do
	ZHunterModOptions.args.trap.args["button"..i] = {
		type = "select",
		name = "Button "..i,
		desc = "Select which spell to use.",
		values = spells,
		style = "dropdown",
		order = 7 + i,
		get = function(info)
			local id = tonumber(info[2]:match("(%d+)"))
			return ZHunterMod_Saved["ZTrap"]["order"][id]
		end,
		set = function(info, v)
			local id = tonumber(info[2]:match("(%d+)"))
			ZHunterMod_Saved["ZTrap"]["order"][id] = v
			if ZTrap then
				ZTrap:Update()
			end
		end
	}
end

function ZTrap:Initialize()
	ZHunterMod_Saved["ZTrap"]["spell"] = {}
	for i = 1, numSpells do
		ZHunterMod_Saved["ZTrap"]["spell"][i] = spells[ZHunterMod_Saved["ZTrap"]["order"][i]]
	end
	self.spells = ZHunterMod_Saved["ZTrap"]["spell"]
	self.anchorevent = ZHunterMod_Saved["ZTrap"]["event"]
	self.direction = ZHunterMod_Saved["ZTrap"]["direction"]
	self.size = ZHunterMod_Saved["ZTrap"]["size"]
	self.count = ZHunterMod_Saved["ZTrap"]["count"]
	self.stack = ZHunterMod_Saved["ZTrap"]["stack"]
	self.rows = ZHunterMod_Saved["ZTrap"]["row"]
end

function ZTrap:OnLoad()
	-- Hide the button if disabled
	if (not ZHunterMod_Saved["ZTrap"]["on"]) then
		self:Hide()
	end
	ZHunterMod_SetBindings()
end